/* . . . . . . BEGIN . . . . . . . . . . . . */
extern void strcpy_et( char aa[], char bb[], int sizeof_aa );

extern void cpauseit();

extern int misc_FindKeyTest( char cc );

extern double misc_md( double pktime );

extern double misc_pk( double md );

extern double degtorad(double theta);

extern double radtodeg(double theta);

extern int cint( double rr );

extern int cnint( double rr );

extern float misc_within_360( float angle );

extern float misc_180( float angle );

extern float misc_convert_angle( float angle );

extern void misc_fix_XYZ( double *XX, double *YY, double *ZZ );

extern void misc_fix_swin( float *xmin, float *xmax, float *ymin, float *ymax );

extern double misc_ast_julday(double epoch);

extern void misc_ast_rotmatrix(double epoch, double p[3][3]);

extern void misc_ast_precess(double  ra1, double  dec1, double epoch1,
                  double *ora2, double *odec2, double epoch2);

extern double misc_hms2deci( int hh, int mm, double ss, int mode );

extern void misc_deci2hms( double dcm, int *hh, int *mm, double *ss, double *thesign );

extern void misc_write_radec(double ura, double udec, int prec, int mode, char ss[]);

extern float misc_ang_sep( float angle1, float angle2 );

extern double misc_ang_sep2( double angle1, double angle2 );

extern double misc_fix_value( double rr );

extern int clc(char a[]);

extern void misc_readlink( char userfile[], char linkfile[], int linkfilesize );

extern int ceos(char a[]);

extern int cindex(char a[], char b[] );

extern int cindex2(char a[], char b[], int ptr );

extern int cindex_reverse(char a[], char b[] );

extern void misc_append_slash( char wrd[] );

extern void misc_delete_file( char wrd[] );

extern void misc_cfitsio_error( int status );

extern void misc_inheadset( fitsfile *fptr, char card[], int value, char comment[] );

extern void misc_fheadset( fitsfile *fptr, char card[], double value, char comment[] );

extern void misc_cheadset(fitsfile *fptr, char card[], char value[], char comment[]);

extern void misc_cheadset_short(fitsfile *fptr,char card[],char value[],char comment[]);

extern void misc_lheadset( fitsfile *fptr, char card[], int value, char comment[] );

extern int misc_card_exist( fitsfile *fptr, char card[] );

extern void misc_cardhead( fitsfile *fptr, char card[], char value[] );

extern void misc_chead_longstr( fitsfile *fptr, char card[], char value[] );

extern void misc_chead_longstr2( fitsfile *fptr, char card[], char value[], char comment[] );

extern void misc_chead( fitsfile *fptr, char card[], char value[] );

extern double misc_fhead( fitsfile *fptr, char card[] );

extern double misc_fhead2( fitsfile *fptr, char card[], char comment[] );

extern int misc_inhead( fitsfile *fptr, char card[] );

extern int misc_inhead2( fitsfile *fptr, char card[], char comment[] );

extern int misc_inhead0( fitsfile *fptr, char card[] );

extern int misc_lhead( fitsfile *fptr, char card[] );

extern void misc_clear_header_card_comments( fitsfile *fptr );

extern void misc_cheadset2( fitsfile *fptr, char prefix[], char card[], char value[], char comment[] );

extern void misc_fheadset2( fitsfile *fptr, char prefix[], char card[], double value, char comment[] );

extern void misc_inheadset2( fitsfile *fptr, char prefix[], char card[], int value, char comment[] );

extern void misc_pad_dots( char wrd0[], int eow, char wrd[] );

extern void misc_pad_dots2( char wrd0[], int eow, char wrd[] );

extern void misc_pad_blanks( char wrd0[], int eow, char wrd[] );

extern void misc_pad_prior_blanks( char wrd0[], int eow, char wrd[] );

extern void misc_set_PRI_maximum( SLtype SL[], GSAXtype GSAX[] );

extern void misc_add_longstrn_comment( fitsfile *fptr );

extern void misc_add_comment(fitsfile *fptr, int tfields, char value[], char comment[]);

extern int misc_find_cfitsio_table_column( char name[], int tfields, char *ttype[], int mode );

extern int misc_ColumnExist( char name[], int tfields, char *ttype[] );

extern int misc_cfitsio_unsigned_long_column_partial( fitsfile *fptr, int colnum, int tfields,
        char *ttype[], long frow, long nelem, int mode, unsigned long aa_long[] );

extern int misc_cfitsio_long_column_partial( fitsfile *fptr, int colnum, int tfields,
                                      char *ttype[], long frow, long nelem,
                                      int mode, long aa_long[] );

extern int misc_cfitsio_unsigned_long_column( fitsfile *fptr, char name[], int tfields,
       char *ttype[], long frow, long nelem, int mode, unsigned long aa_long[] );

extern int misc_cfitsio_long_column( fitsfile *fptr, char name[], int tfields,
                              char *ttype[], long frow, long nelem, int mode,
                              long aa_long[] );

extern int misc_cfitsio_string_column( fitsfile *fptr, char name[], int tfields,
                              char *ttype[], long frow, long nelem, int mode,
                              char *aa_string[] );

extern int misc_cfitsio_byte_column( fitsfile *fptr, char name[], int tfields,
                              char *ttype[], long frow, long nelem, int mode,
                              unsigned char aa_byte[] );

extern int misc_cfitsio_short_column( fitsfile *fptr, char name[], int tfields,
                               char *ttype[], long frow, long nelem, int mode,
                               short aa_short[] );

extern int misc_cfitsio_double_column( fitsfile *fptr, char name[], int tfields,
                                char *ttype[], long frow, long nelem, int mode,
                                double aa_double[] );

extern int misc_cfitsio_float_column( fitsfile *fptr, char name[], int tfields,
                               char *ttype[], long frow, long nelem, int mode,
                               float aa_float[] );

extern int misc_cfitsio_get_table_naxis2( char ffile[] );

extern void misc_cfitsio_get_character_card( char ffile[], int hdu, char cardname[],
                                      char cardval[]  );

extern int misc_cfitsio_get_int_card( char ffile[], int hdu, char cardname[]  );

extern double misc_cfitsio_get_double_card( char ffile[], int hdu, char cardname[]  );

extern void misc_cfitsio_get_array_double_cards( char ffile[], int hdu, int numcard,
                                            char cardname[200][9], double value[]  );

extern int misc_mcat_set_ttype_tform_tunit( char *ttype[], char *tform[], char *tunit[], int nuv_naper,
                                     int fuv_naper, int nuv_nfolr, int fuv_nfolr );

extern int misc_gsp_set_ttype_tform_tunit( char *ttype[], char *tform[], char *tunit[] );

extern int misc_readpho(FILE *phofu,
                 char phohead[], double *RAorigin, double *DECorigin,
                 phofp pholist[], double scales[2][6] );

extern int misc_readphoheader(char phofile[], char phohead[],
                   double *RAorigin, double *DECorigin, double scales[2][6] );

extern int misc_readphoheader2(char phofile[], char phohead[],
       double *RAorigin, double *DECorigin, double scales[2][6],
       int *PHseed, double *PHpssd, double *PHfwhm, double *PHradius,
       char PHsourcefile[], char PHbandpass[],
       double *PHtime, double *PHgrspa, double *PHlamc);

extern void misc_Photon_Scale_Type4( double RAo, double DECo,
                        double tzero[], double tscal[] );

extern void misc_AddNotesBinaryFITS_typeform(int num, char header[], int headersize);

extern void misc_AddNotesBinaryFITS( char h1[], char h2[], int hs );

extern int misc_readphoimage(char phofile[], double scale,
                      double RAcenter, double DECcenter,
                      double xmin, double xmax,
                      double ymin, double ymax, double PA, int maxblock,
                      float image[], int *numcol, int *numrow, char ph[],
                      double *RAo, double *DECo );

extern void misc_SetIOP_from_FITS_header( char header[], int headersize, IOPtype IOP[1]);

extern void misc_xyz2uv(double x, double y, double z, double *u, double *v, RMtype RM );

extern void misc_radec2colrow( IOPtype IOP, double ra, double dec, RMtype RM, double *col, double *row );

extern void misc_colrow2radec( IOPtype IOP, double col, double row, RMtype RM, double *ra, double *dec );

extern void misc_colrow2radec_quick( IOPtype IOP,
                              double col, double row, RMtype RM,
                              double *ra, double *dec,
                              double ycp, double zcp );

extern void misc_colrow2prime_quick( IOPtype IOP,
                              double col, double row, RMtype RM,
                              double *yp, double *zp,
                              double ycp, double zcp );

extern FILE *fopen_read( char file[] );

extern FILE *fopen_write( char file[] );

extern int misc_scan_csv( FILE *infu, int num, double v[] );

extern int misc_scan_values( FILE *infu, int num, double v[] );

extern double hexvalue( char cc );

extern void hexbinarystring( char cc, char ss[] );

extern void show_binary64( unsigned long long int ii, char bs[] );

extern void show_binary32( unsigned int ii, char bs[] );

extern void show_binary16( unsigned short int ii, char bs[] );

extern void show_binary8( unsigned char ii, char bs[] );

extern void WriteString9(double value, char ss[]);

extern void WriteString7(double value, char ss[]);

extern void misc_FlipImage( float image[], int ncol, int nrow, int mode );

extern void misc_ClipImage( float image[], int *ncol, int *nrow,
                     int sc, int ec, int sr, int er );

extern void misc_ExpandImage( float image[], int *ncol, int *nrow, int expand,
                       float newimage[] );

extern void misc_BinImage( float image[], int *ncol, int *nrow, int bin, int mode );

extern void misc_BinImageMask( short msk[], int *ncol, int *nrow, int bin );

extern void cDoBin8(int bin, int *np, double xx[], int mode);

extern void cDoBin4(int bin, int *np, float xx[], int mode);

extern void misc_system3( char wrd[], FILE *outfu );

extern void misc_system( char wrd[] );

extern void misc_system2( char wrd[], int test );

extern void misc_systest( char wrd[] );

extern void misc_echo( char wrd[] );

extern int timeget();

extern int gmtimeget();

extern int ssny();

extern void timegetstring(char uline[]);

extern void timegetstring_gmt(char uline[]);

extern void misc_current_datestring( char ds[] );

extern void misc_printdate();

extern void getsystime( char uline[] );

extern void bswp2(char bb[]);

extern void bswp8(char bb[]);

extern void SwapDouble( double *value );

extern void bswp4(char bb[]);

extern void SwapFloat( float *value );

extern void SwapFloatUnion( int *value );

extern void GateSwapFloatUnion( float *value );

extern unsigned short int ByteSwap2us( unsigned short int ii );

extern short int ByteSwap2( short int ii );

extern long int ByteSwap4( long int ii );

extern unsigned long long int ByteSwap8us( unsigned long long int llii );

extern unsigned long long int ByteSwap8us_2J( unsigned long long int llii );

extern long int SwapLong( long int ii );

extern short int SwapShort( short int ii );

extern int misc_read_usnoa_zone_file( FILE *infu, int num, int *nn, double ra[],
                               double dec[], float blue[], float red[] );

extern void misc_dissect_ggoid( unsigned long long int ggoid,
       int *vsn, int *tilenum, int *type, int *ow, int *prod,
       int *img, int *try, int *band, int *xid );

extern unsigned long long int make_galex_global_ID( int vsn, int tilenum, int type, int ow, int prod,
                                             int img, int try, int band, int xid);

extern void misc_break_ggoid( unsigned long long int ulli,
                       unsigned long *ui1, unsigned long *ui2 );

extern unsigned long long int misc_join_ggoid( unsigned long ui1, unsigned long ui2 );

extern double FindRADiff(double ra1, double ra2);

extern double FindRAMean(double ra1, double ra2);

extern double cpolyval(int nc, double co[], double xv);

extern int cneari(double xx, int narr, double arr[]);

extern int cneari4(float xx, int narr, float arr[]);

extern int cneari_bs(double xx, int narr, double arr[]);

extern int cneari_bs_int(int xx, int narr, int arr[]);

extern int cneari_bs4(float xx, int narr, float arr[]);

extern int cneari_bs_MOEA( double ww, MOEAtype MOEA[] );

extern int cneari_bs_SXS( float offset, SXStype SXS[], int npix );

extern int cneari_bs_SYN( float teff, SYNtype SYN[] );

extern float misc_nearx_GAA( float area, GAAtype GAA );

extern void strprefix( char a[], char b[] );

extern void strprefix_wb( char a[], char b[] );

extern void substrprt(char a[], int a1, int a2 );

extern void substrcpy( char a[], int a1, int a2, char b[], int b1 );

extern void substrcpy2( char a[], int a1, int a2, char b[], int b1 );

extern void substrcpy_terminate( char a[], int a1, int a2, char b[], int b1 );

extern int substrcmp(char a[], int a1, int a2, char b[], int b1 );

extern int substrcmp0(char a[], char b[], int n );

extern void cupper_case(char a[]);

extern void clower_case(char a[]);

extern void clean_control_M( char ss[] );

extern int cfc(char a[]);

extern void misc_trim_blanks(char wrd[]);

extern float misc_ppm_to_value( char cc );

extern char misc_value_to_ppm( float hv );

extern void cargcopy(char *argv[], int argc, int *narg, char arg[202][SSS]);

extern void cargscopy(char *argv[], int argc, int *nargs, char args[40][8000]);

extern void misc_parse_words( char line[], char wrds[20][40], int *nwrds );

extern void misc_parse_big_words( char line[], char wrds[50][200], int *nwrds );

extern void misc_parse_deliminated_words(char line[],char delim,char wrds[20][40],int *nwrds);

extern void cargscopy2( char *argv[], int argc, int *nargs, char *args[],
                 int maxarg, int maxss );

extern int cfindarg(char arg[202][SSS], int *narg, char parm[], char d, char wrd[] );

extern int cfindargs2( char *args[], int *nargs, char parm[], char delim,
                char *wrds[], int *nwrds, int maxwrd, int maxwss );

extern int cfindarg2( char *args[], int *nargs, char parm[], char delim, char wrd[] );

extern int cfindarg2_cis( char *args[], int *nargs, char parm[], char delim, char wrd[] );

extern int cfindargs( char args[40][8000], int *nargs, char parm[], char delim,
               char wrds[202][SSS], int *nwrds );

extern int last_cfindarg(char arg[202][SSS], int *narg, char parm[], char d,char wrd[]);

extern int last_cfindarg2(char *args[],int *nargs,char parm[],char delim,char wrd[]);

extern int last_cfindarg2_cis(char *args[],int *nargs,char parm[],char delim,char wrd[]);

extern int last_cfindargs2( char *args[], int *nargs, char parm[], char delim,
                     char *wrds[], int *nwrds, int maxwrd, int maxwss );

extern double cangsep(double ra1, double dec1, double ra2, double dec2);

extern double misc_position_angle(double ra1, double dec1, double ra2, double dec2);

extern double xinterp( int n, double x[], double xpt );

extern float xinterp4( int n, float x[], float xpt );

extern double yinterp(int n, double x[], double y[], double xpt);

extern double yinterp2(int n, double x[], double y[], double xpt);

extern double yinterp2c(int n, const double x[], const double y[], double xpt);

extern double TypeToTemp(char st[2], float *typeval);

extern int numeral(char cc);

extern int numeric(char cc);

extern int numeric_string(char wrd[]);

extern int nondelim( char cc, int mode );

extern int misc_get_number_of_IPAC_columns( char ipachead[] );

extern void misc_get_IPAC_columns( char ipachead[], ITCtype ITC[] );

extern int misc_find_IPAC_column( char username[], ITCtype ITC[], int mode );

extern void misc_load_IPAC_columns( char ipachead1[], char ipachead2[], ITCtype ITC[] );

extern double cvalread(char userline[], int up1, int up2);

extern double cvalread0( char userline[], int up1, int up2 );

extern void FindWord( char line[], int pp, int *sow, int *eow, int *ok, int mode );

extern void FindNumericWord(char line[], int pp, int *sow, int *eow, int *ok);

extern double GetLineValue(char line[], int nn);

extern double GetLineValueQuiet(char line[], int nn);

extern double GetLineValueVerbose(char line[], int nn);

extern double GLVQ(char line[], int nn);

extern double GLV(char line[], int nn);

extern double getarg( char arg[202][SSS], int *narg, char parm[], double defval );

extern int fgetline(char userline[], FILE *fu);

extern int fgetline_complete(char userline[], FILE *fu);

extern void misc_timepidstring( char timepid[] );

extern void misc_timepidstring2( char timepid[] );

extern void misc_getpath( char currpath[] );

extern int FileExist( char filename[] );

extern int FileExist_gz( char filename[] );

extern int FileExist_ungz( char filename[] );

extern int FileExist_ungz_cp( char filename[], char mydir[], char newfile[] );

extern int FileExistFits( char filename[] );

extern int FileEmpty( char filename[] );

extern int FileEmpty_gz( char filename[] );

extern void misc_file_trap( char newfile[], char comment[] );

extern int misc_last_underscore_number( char line[] );

extern int misc_last_hyphen_number( char line[] );

extern void misc_replace_use( char line[] );

extern int misc_get_tileid_from_tilename( char tilename[], char tempfile[] );

extern void misc_replace_all_use( char file[], int quiet );

extern void misc_replace_all_use_and_forest( char file[], char tempfile[] );

extern int misc_get_scst_subvisit( char scstfile[], int quiet );

extern double misc_get_double_IPAC( char line[], char colname[], ITCtype ITC[], int mode );

extern void misc_get_character_IPAC( char line[], char colname[], ITCtype ITC[], int mode, char wrd[] );

extern void misc_dissect_img( int vsn, int img, int *visit, int *subvis );

extern void misc_new_img( int vsn, int *img, int subvis );

extern void misc_get_tilename_from_path( char path[], char tilename[] );

extern void misc_ggoid_values_from_path( char file[], int *vsn, int *tilenum, int *type,
                                  int *ow, int *prod, int *img, int *try, int *band, int quiet );

extern void misc_echo_ggoid( unsigned long long int ulli );

extern void misc_load_integer_series( char wrd[], int *nkey, int key[], int maxkey );

extern void misc_load_integer_sequence( char wrd[], int *nkey, int key[], int maxkey );

extern void misc_load_eclipse_galextimes( int GSCT[] );

extern double misc_eclipse_to_galextime( int eclipse, int GSCT[] );

extern double misc_galextime_to_unixtime( double galextime );

extern double misc_unixtime_to_galextime( double unixtime );

extern double misc_datestring_to_unixtime_2( char ds[] );

extern double misc_datestring_to_unixtime( char ds[] );

extern double misc_convert_time_string( char ts[] );

extern void misc_reverse_unix_time( double unixtime, char ts[] );

extern FILE *fopen_for_append( char oldfile[], char newfile[] );

extern float readrealstdin();

extern double StarTempBmV(double userbv);

extern double BlackBodyAT( double a, double T, double x );

extern double SolveBlackBodyA( int nn, float xx[], float yy[], float ww[], double T );

extern double LeastSquaresBlackBody( int nn, float xx[], float yy[], float ww[],
                               double T, double a );

extern void FitBlackBody( int nn, float xx[], float yy[], float ww[],
                   double *T, double *a );

extern double IntegrateBlackBody(double lam1, double lam2, double Teff,
                          double flam0, double lam0);

extern void BB_GalexRateBV(double B, double V, double *FUVrate, double *NUVrate);

extern double gammln(double xx);

extern void gser(double a, double x, double *gamser, double *gln);

extern void gcf(double a, double x, double *gammcf, double *gln);

extern double gammq(double a, double x);

extern double chisq_test(double nu, double chisq);

extern int Hits(double ACR);

extern void GaussianPosition(double fwhm, double *radius, double *theta);

extern void PoissonArray( double mean, double xx_start, double xx_end, double xx_inc,
                   int maxarr, double array[], int *nn );

extern double doub_rand(double a, double b);

extern void cqcksrt4(int nn, float arr[] );

extern void cqcksrt8(int nn, double arr[] );

extern void cqcksrtkey4(float arr[], int nkey, int key[] );

extern void cqcksrtkey8(double arr[], int nkey, int key[] );

extern float cfind_median_key(float arr[], int nkey, int key[] );

extern float cfind_median(int nn, float arr[] );

extern float cfind_median_average( int nn, float arr[], int nrej );

extern double cfind_median8(int nn, double arr[] );

extern double cfind_median_average8( int nn, double arr8[], int nrej );

extern float cfind_median_rejections( int npt, float dat[], float wt[],
                               float arr[], float rejsig, int maxrej );

extern float cfind_median_deviant_average( int nn, float arr[], int nrej, int mask[],
                                    float *rms );

extern float cfind_median_scratch(int nn, float arr[], float scr[] );

extern double cfind_median8_rms(int nn, double arr[], double *rms );

extern double cfind_median_scratch8(int nn, double arr[], double scr[] );

extern void cASCII_to_PS(char afile[], char psfile[],
                 int ptsz, int left, int bold, int land,int head);

extern double GetPixelPosition( float xx[], int nn, double xval );

extern void FluxAverage( float ff[], float ee[], double pix1, double pix2,
                  int sumit, double *fval, double *eval );

extern double FluxSum( double ff[], double pix1, double pix2 );

extern void SmoothArray8( int radius, int num, double arr[], double scr[] );

extern void cwrite_radec(double ra, double dec, char ss[], int mode);

extern void cread_column_data( char datafile[], int type, int maxpt,
                        int *nn, float xx[], float yy[], float zz[] );

extern void cread_column_data2( char file[], int type, int nfile, int maxpt,
                         int *nrow, int *ncol, float aa[] );

extern int misc_read_CSV( char file[], int xxtc, int yytc, float xx[], float yy[] );

extern void misc_read_IPAC_column_names( char infile[], char *names[], char *forms[], int *nc );

extern void misc_read_IPAC( char file[], char *names[], int nc, int maxpt, int *nr, float img[] );

extern void misc_read_IPAC_double( char file[], char *names[], int nc, int maxpt, int *nr, double img[] );

extern void misc_grab_line( char sss[], int *ptr, char line[] );

extern void show_string_of_lines( char sss[], int mode );

extern void show_string_of_lines2( char sss[], int mode, char parm[] );

extern int params_help_arg( char arg[202][SSS], int *narg, char params[], char version[] );

extern int params_help_arg2( char *args[], int *nargs, char params[], char version[] );

extern int misc_get_visit_from_path( char path[] );

extern char misc_get_owc_from_path( char path[] );

extern char misc_get_mainflag_from_path( char path[] );

extern void misc_get_subvisit_string_from_path( char path[], char subvis[] );

extern int misc_get_try_from_path( char path[] );

extern int misc_get_try_from_path2( char path[], char timepid[] );

extern int misc_get_vsn_from_path( char path[] );

extern int misc_get_tile_id_from_path( char path[] );

extern void misc_get_obsname_from_path( char path[], char obsname[] );

extern void misc_get_disk_from_path( char path[], char disk[] );

extern void misc_swap_SBS( SBStype SBS[] );

extern void misc_swap_PBS( PBStype PBS[] );

extern void misc_swap_RWM( RWMtype RWM[], int num );

extern void misc_swap_ACT( ACTtype ACT[], int num );

extern void misc_swap_RWM2( RWM2type RWM2[], int num );

extern void misc_swap_PRIRW( PRIRWtype PRIRW[], int num );

extern void misc_swap_RWSL( RWSLtype RWSL[], int num );

extern void misc_swap_ACEX( ACEXtype ACEX[], int num );

extern void misc_swap_SXS( SXStype SXS[], int num );

extern void misc_swap_STD( STDtype STD[] );

extern void misc_swap_RSSL( RSSLtype RSSL[], int num );

extern int misc_ichar( char cc );

extern void misc_ReadFitsTableColumn( fitsfile *fptr, int naxis2, int colnum, char form[], double data[] );

extern void misc_ReadFitsTable_double( char file[], int maxpt, int *nn,
                                char name[], double data[], int quiet );

extern void misc_ReadFitsTable_float( char file[], int maxpt, int *nn,
                               char name[], float data[], int quiet );

extern void misc_ReadFitsTable_int( char file[], int maxpt, int *nn,
                             char name[], int data[], int quiet );

extern void misc_ReadFitsTable_short( char file[], int maxpt, int *nn,
                               char name[], short data[], int quiet );

extern void misc_mean_rms( int nn, float aa[], double *mean, double *rms );

extern void misc_mean_rms_weight( int nn, float aa[], float ww[], double *mean, double *rms );

extern void misc_mean_rms8( int nn, double aa[], double *mean, double *rms, double *minv, double *maxv );

extern int misc_rw_phoconv6to3( char file6[], char file3[], LIM6type LIM6 );

extern int misc_rw_phoconv0to3( char phofile[], char fitsfile[] );

extern int misc_rw_phoconv0to4( char phofile[], char fitsfile[] );

extern int misc_readbinfits_data_abr_cfitsio(fitsfile *fptr, double tzero[],
                                      double tscal[], int pcount, int numpho,
                                      phofp pholist[] );

extern int misc_photon_mask_flag( unsigned short int flags );

extern int misc_readbinfits_data_cfitsio(fitsfile *fptr, int pcount, int totnumpho, phofp pholist[] );

extern int misc_readbinfits_data_expho_cfitsio(fitsfile *fptr,int pcount,int totnumpho, phofp pholist[] );

extern int misc_readbinfits_data_raw6_nocal_cfitsio(fitsfile *fptr,int pcount,int totnumpho, phofp pholist[], LIM6type LIM6 );

extern int misc_readbinfits_data_expho( FILE *phofu, phofp pholist[] );

extern int misc_readbinfits_data(FILE *phofu, phofp pholist[] );

extern int misc_readbinfits_data_real( FILE *phofu, phofp pholist[] );

extern int misc_readbinfits_data_abr(FILE *phofu, phofp pholist[],
                              double tzero[], double tscal[] );

extern int misc_GrabPhotons_cfitsio( GSAXtype GSAX, fitsfile *fptr, int pcount, phofp pholist[], LIM6type LIM6 );

extern int misc_fitspho2image( char phofile[], IOPtype UserIOP, LIM6type LIM6,
                        char phoheader[], char imgheader[], int headersize,
                        float image[], int photon_limit );

extern int misc_fitspho2image_slice( char phofile[], IOPtype UserIOP, LIM6type LIM6,
        char phoheader[], char imgheader[], int headersize, char time_root[],
        double time_start, double time_offset, double time_inc, int time_num,
        float image[], int photon_limit );

extern int misc_rw_phoconv4to4_disperse( char file1[], char file2[], double fwhm,
                                  double disp, double lamc, double grspa,
                                  int seed );

extern int misc_rw_phoconv4to4( char file1[], char file2[], int new_phonum );

extern int misc_rw_phoconv3to3( char file1[], char file2[], int new_phonum );

extern int misc_rw_phoconv3to4_dsp( char file1[], char file2[], double ClipRadius,
                             double fwhm, double grspa, int seed,
                             int bandnumber, int grdisp, int toddsim );

extern int misc_rw_phoconv3to3_dsp( char file1[], char file2[], double ClipRadius,
 double fwhm, double grspa, int seed, int bandnumber, int grdisp, int toddsim );

extern int misc_rw_phoconv4to3( char file1[], char file2[],
                         double time0, double tottime );

extern void misc_read_XSP( char xspfile[], XSPtype XSP[], int *numsp );

extern void misc_read_GSP( char GSP_file[], int max_GSP, GSPtype GSP[], int *numsp,
                    GSAXtype GSAX[], ACEXtype ACEX[], char spexvers[] );

extern void misc_fullpath( char file[], char fullpath[], char justfile[] );

extern void misc_add_fullpath( char file[] );

extern int misc_GetSubLine( int *ptr, char line[], char subline[], FILE *infu );

extern float misc_FluxNoise( float flux, float ferr, int ng, float xg[], float ag[] );

extern void misc_load_colormap( char colorfile[], CLMtype CLM[] );

extern void misc_write_ppm3( char ppmfile[], float image[], int nc, int nr,
                      float bg, float fg, CLMtype CLM[] );

extern void misc_read_ppm6( char ppmfile[], int max_spfi, float spfi[], float bg, float fg,
                     int *nc, int *nr );

extern void misc_read_general_ppm6( char ppmfile[], int max_color_image, char *color_image[3], int *nc, int *nr );

extern void misc_write_general_ppm6( char ppmfile[], char *color_image[3], int nc, int nr );

extern void misc_write_pix(FILE *outfu, float value, CLMtype CLM[], float bg, float fg);

extern void misc_write_ppm6( char ppmfile[], float image[],
                      int nc, int nr, float bg, float fg,
                      int bsc, int bsr, int bnc, int bnr,
                      CLMtype CLM[], char topbar[], char bottombar[] );

extern int misc_largest_subvisit( char path[] );

extern void misc_read_fits_columns( char ffile[], int ncol, char colnames[600][80],
                             int srow, int hdunum, int rowlimit, int maximage,
                             int info, int verbose,
                             int maxfield, char *ttype[], char *tform[],
                             double image[], int *nrow_ret, char forms[], int quiet );

extern void misc_rotate_right( float image[], int ncol, int nrow );

extern void  misc_clear_gsp( GSPtype GSP[] );

extern void misc_clear_MCQA( MCQAtype MCQA[] );

extern void misc_mast_jpegfile( char jpegroot[], int id, char type[], char jpegdir[], char jpegfile[] );

extern void misc_get_absdir( char path[], char timepid[], char absdir[] );

extern void misc_grab_AbsPipeDir( char base[], int tileid, char tilename[], char ow[], int mode, int visit, char AbsPipeDir[] );

extern void misc_detector_xy( double ra, double dec, RMtype RM, double RotMat[2][2], double *detx, double *dety );

extern void misc_convert_datestring( char date1[], char date2[], int *mode );

extern int misc_filelistdate( char listline[], char datec[], char timec[], char datetime[] );

extern int misc_filedate( char file[], char datec[], char timec[], char datetime[] );

extern int misc_file_unixtime_UTC( char file[] );

extern int misc_file_size( char file[] );

extern int misc_filedate_UTC( char file[], char datec[], char timec[], char datetime[], int mode );

extern int misc_filesecs_UTC( char file[] );

extern int misc_SubtractFileDates( char file1[], char file2[] );

extern void misc_add_gsp_table_comments( fitsfile *fptr, int tfields );

extern void misc_create_series_list( int nn, int iarr[], int mode, char arrlist[] );

extern void misc_spectral_s2n( double direct, double mag, double zpmag, double exptime,
                        double respdip, double backrate, double eacorr, double aperfrac,
                        double objwidth, double psf_fwhm, double disp, double wave_range, int verbose,
                        double *s2n_resel, double *s2n_ang );

extern void misc_predicted_spectral_s2n( int bandnumber, double nuv_flux, double fuv_flux, double exptime,
                                  double *s2n_resel, double *s2n_ang, double *s2n_order );

extern void misc_absorption_width( float yy[], int ba1, int ba2, int bb1, int bb2, float *width, float *peak );

extern void misc_cfitsio_read_image( char ffile[], float image[], int maxpix, char header[], int headersize );

extern void misc_cfitsio_write_image( char ffile[], float image[], int nc, int nr, int maxpix, char header[], int headersize );

extern void misc_manual_qa_info( char trydir[], char subvis[], MQAtype MQA[], char mqafile[] );

extern void misc_redux_string( char reduxfile[], char redux[], int *iredux );

extern void misc_full_pathway( char path[], char fullpath[], char disk[] );

extern void misc_load_DRI( DRItype DRI[] );

extern void misc_gwr_clear_cECL( cECLtype cECL[] );

extern void misc_gwr_clear_AFS( AFStype AFS[], int eemax );

extern void misc_gwr_read_AFS( AFStype AFS[], char suffix[], int eemax );

extern void misc_gwr_DRI_release_strings( char user_subpath[], DRItype DRI[], int mode, char grrs[], char girs[], FILE *outfu );

extern void misc_gwr_add_flag( char wrd[], char flag[] );

extern void misc_preclip_string( char wrd[], int maxchar );

extern void misc_preclip_string2( char wrd[], int maxchar );

extern void misc_clip_string( char wrd[] );

extern void misc_pad_string( char wrd0[], int eow, char wrd[] );

extern void misc_gwr_read_chkmps( char chkmpsfile[], cECLtype cECL[] );

extern void misc_gwr_tile_eclipse_coadd_table( char flags[], CTDtype CTD, int AFS_me, AFStype AFS[] );

extern int misc_redux_seconds( char wrd[] );

extern int misc_gwr_number_of_unique_values( int na, int aa[], int nb, int bb[] );

extern void misc_gwr_write_coadd_table( int AFS_me, AFStype AFS[], char outfile[], char suffix[], int WriteTileCoadd, char owc, int ntilenames, char *tilenames[]  );

extern void misc_load_IDD( IDDtype IDD, char column[], double aa[] );

extern void misc_read_IDD( char ipacfile[], char columns[], IDDtype *IDD );

extern void misc_free_IDD( IDDtype IDD );

extern void misc_load_IFD( IFDtype IFD, char column[], float aa[] );

extern void misc_read_IFD( char ipacfile[], char columns[], IFDtype *IFD );

extern void misc_free_IFD( IFDtype IFD );

extern int misc_gregorian_to_julian( int year, int month, int day );

extern void misc_julian_to_gregorian( int jd, int *year, int *month, int *day );

extern double misc_zulu_to_julian( char zdate[] );

extern void misc_julian_to_zulu( double djd, char zdate[] );

extern double misc_julian_to_uth( double djd );

extern double misc_zulu_to_decimal_year( char zdate[] );

extern double current_julian();

extern double misc_doy_to_julian( int year, double doy );

extern void misc_doy_to_calendar( int year, int doy, char ds[] );

/* . . . . . . END . . . . . . . . . . . . . */
